# -*- coding: utf-8 -*- 
# (C) Copyright (C) ?, Massimo di Piero
# (C) Copyright (C) 2012, 2013 Pablo Angulo: added support for zip files


#########################################################################
## This is a samples controller
## - index is the default action of any application
## - user is required for authentication and authorization
## - download is for downloading files uploaded in the db (does streaming)
## - call exposes all registered services (none by default)
#########################################################################  
from __future__ import with_statement # This isn't required in Python 2.6     
__metaclass__ = type
import os
import sys
import time
try:
    from PIL import Image
except ImportError:
    raise HTTP(200,"Requires the Python Imaging Library installed")
from gluon.contrib import simplejson as json
import urllib
import datetime
now=datetime.datetime.now()
split_path = os.path.split
split_ext = os.path.splitext
path_exists = os.path.exists
normalize_path = os.path.normpath
absolute_path = os.path.abspath 
encode_urlpath = urllib.quote_plus
output=os.path.join(request.folder,'static','test.txt')


#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
def index():
    igrupo=int(request.vars.grupo)
    appname=request.application
    return dict(appname=appname, grupo=igrupo)
    
#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
@service.json
def getinfo(path):
    igrupo=int(request.vars.grupo)
    if path=='True':
        path=request.vars.path
    else:
        path=path
    row=db((db.allfiles.filepath==path)&(db.allfiles.grupo==igrupo)).select()[0]
    abspath=request.folder+path
    iconfolder='static/images/fileicons/'
    absiconlocation=request.folder+iconfolder
    iconlocation='/'+request.application+'/'+iconfolder
    filename=row.filename
    filetype=row.filetype
    datecreated=row.datecreated
    datemodified=row.datemodified
    filesize=row.filesize
    thefile = {
            'Filename' : filename,
            'FileType' : '',
            'Preview' : iconlocation+'_Open.png' if filetype=='dir' else '' ,
            'FilePreview':'',
            'Path' : path,
            'Error' : '',
            'Code' : 0,
            'Properties' : {
                    'Date Created' : '',
                    'Date Modified' : '',
                    'Width' : '',
                    'Height' : '',
                    'Size' : ''
             }
            }
            
    imagetypes = set(['gif','jpg','jpeg','png','bmp'])      
        
    if filetype=='dir':
        thefile['FileType'] = 'Directory'
    else:
        thefile['FileType'] = filetype  
        if filetype in imagetypes:
            thefile['Preview']='/'+request.application+'/default/download/'+row.file
        elif filetype=="mp3" or filetype=="flv":
            thefile['FileType']='media'
            embedfile='/'+request.application+'/default/download/'+row.file          
            thefile['FilePreview']=str(plugin_mediaplayer(embedfile,400,300))
            previewPath = iconlocation + filetype.lower() + '.png'
            abspreviewPath=absiconlocation+filetype.lower()+'.png'
            thefile['Preview'] = previewPath if os.path.exists(abspreviewPath) else iconlocation+'default.png'
        else:
            previewPath = iconlocation + filetype.lower() + '.png'
            abspreviewPath=absiconlocation+filetype.lower()+'.png'
            thefile['Preview'] = previewPath if os.path.exists(abspreviewPath) else iconlocation+'default.png'
        
    thefile['Properties']['Date Created'] = datecreated 
    thefile['Properties']['Date Modified'] = datemodified
    thefile['Properties']['Size'] = filesize
    return thefile
     
#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
@service.json   
def getdata():
    igrupo=int(request.vars.grupo)
    path=request.vars.path
    data=db((db.allfiles.filepath==path)&(db.allfiles.grupo==igrupo)).select()[0]
    textdata=data.content
    return textdata

#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
def updatedata():
    igrupo=int(request.vars.grupo)
    data=request.vars.senddata
    path=request.vars.getpath
    db((db.allfiles.filepath==path)&(db.allfiles.grupo==igrupo)).update(content=data)
    return 'Updated!!!'
 
#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
@service.json
def getfolder():
    igrupo=int(request.vars.grupo)   
    path=request.vars.path
    rows=db((db.allfiles.parentpath==path)&(db.allfiles.grupo==igrupo)).select()    
    result = {}
    for row in rows:
        result[row.filepath]=getinfo(row.filepath)
    return result

#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
def browsefiles():
    igrupo=int(request.vars.grupo)
    files=db((db.allfiles.grupo==igrupo)&(db.allfiles.filetype !='dir')).select()
    result={}
    filetypes= set(['gif','jpg','png','bmp','swf'])
    for rfile in files:
        if rfile.filepath[-3:] in filetypes:
            result[rfile.filepath]=getfileinfo(rfile.filepath)
    return dict(result=result,cknum=request.vars.CKEditorFuncNum)
    
#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
def getfileinfo(path):
    igrupo=int(request.vars.grupo)
    row=db((db.allfiles.filepath==path)&(db.allfiles.grupo==igrupo)).select()[0]
    abspath=request.folder+path
    iconfolder='static/images/fileicons/'
    absiconlocation=request.folder+iconfolder
    iconlocation='/'+request.application+'/'+iconfolder
    filename=row.filename
    filetype=row.filetype
    filesize=row.filesize
    thefile = {
            'Filename' : filename,
            'FileType' : '',
            'Preview' : iconlocation+'_Open.png' if filetype=='dir' else '' ,
            'FilePreview':'',
            'Path' : path,
            'Error' : '',
            'Code' : 0,
            'Properties' : {
                    'Width' : '',
                    'Height' : '',
                    'Size' : ''
             }
            }
            
    imagetypes = set(['gif','jpg','jpeg','png','bmp'])      
        
    if filetype=='dir':
        thefile['FileType'] = 'Directory'
    else:
        thefile['FileType'] = filetype  
        if filetype in imagetypes:
            thefile['Preview']='/'+request.application+'/default/download/'+row.file
        elif filetype=="mp3" or filetype=="flv":
            thefile['FileType']='media'
            embedfile='/'+request.application+'/default/download/'+row.file          
            thefile['FilePreview']=str(plugin_mediaplayer(embedfile,400,300))
            previewPath = iconlocation + filetype.lower() + '.png'
            abspreviewPath=absiconlocation+filetype.lower()+'.png'
            thefile['Preview'] = previewPath if os.path.exists(abspreviewPath) else iconlocation+'default.png'
        else:
            previewPath = iconlocation + filetype.lower() + '.png'
            abspreviewPath=absiconlocation+filetype.lower()+'.png'
            thefile['Preview'] = previewPath if os.path.exists(abspreviewPath) else iconlocation+'default.png'        
    thefile['Properties']['Size'] = filesize
    return thefile


#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
def dirlist():
    igrupo=int(request.vars.grupo)
    import re
    r=['<ul class="jqueryFileTree" style="display: none;">']
    path=request.post_vars.dir or '/'
    rows=db((db.allfiles.parentpath==path)&(db.allfiles.grupo==igrupo)).select()
    for row in rows:
        if row.filetype=='dir':
            r.append('<li class="directory collapsed"><a href="#" rel="%s">%s</a></li>' % (row.filepath,row.filename))    
    r.append('</ul>')
    return r

#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
@service.json
def addfolder(param):
    igrupo=int(request.vars.grupo)    
    filename=request.vars.name.replace(' ','_')
    parentpath=request.vars.path
    filepath=parentpath+filename+'/'
    rows=db((db.allfiles.filepath==filepath)&(db.allfiles.grupo==igrupo)).select()
    recordexists=len(rows)
    if not recordexists:
        db.allfiles.insert(filename=filename,filepath=filepath,parentpath=parentpath,filetype='dir',datecreated=now,grupo=igrupo)
        result= {
                    'Parent' : parentpath,
                    'Name' : filename,
                    'Error' :'',
                    'Code' :0
                    }
    else:
        result = {
                    'Path' : parentpath,
                    'Name' : filename,
                    'Code' : 1,
                    'Error' : 'Folder already exists'
                }
    return result

#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
@service.json
def unzip(param):    
    igrupo=int(request.vars.grupo)
    filepath=request.vars.file
    parentpath,filename=os.path.split(filepath)
    foldername,_=os.path.splitext(filename)
    folderpath,_=os.path.splitext(filepath)
    folderpath=folderpath+'/'
    parentpath=parentpath+'/'
    
    rows=db((db.allfiles.filepath==folderpath)&(db.allfiles.grupo==igrupo)).select()
    recordexists=len(rows)
    ziprecord=db.allfiles(filepath=filepath, grupo=igrupo)
    if ziprecord and not recordexists:
        import zipfile
        targetfile = db.allfiles.file.retrieve(ziprecord.file)[1]
        zipf = zipfile.ZipFile(targetfile,'r')
        if (any(fn.startswith('/') for fn in zipf.namelist()) or 
            any('..' in fn for fn in zipf.namelist())):
            result = {
                        'Path' : parentpath,
                        'Name' : filename,
                        'Code' : 1,
                        'Error' : 'Problem with zip file'
                    }
        else:
            db.allfiles.insert(filename=foldername, filepath=folderpath,
                               parentpath=parentpath, filetype='dir', 
                               datecreated=now, grupo=igrupo)
            zipparent = targetfile.name + '_content'
            zipf.extractall(zipparent)
            parentpath=parentpath+foldername+'/'
            for fn in zipf.namelist():
                if fn.endswith('/'):
                    newpath = parentpath+fn[:-1]
                    newppath, newname = os.path.split(newpath)
                    db.allfiles.insert(filename=newname, filepath=newpath+'/',
                                       parentpath=newppath+'/', filetype='dir', 
                                       datecreated=now, grupo=igrupo)
                else:
                    newpath   = parentpath+fn
                    newppath, newname = os.path.split(newpath)
                    _, newext = os.path.splitext(newname)
                    newext    = newext[1:]
                    newname   = unicode.encode(unicode(newname),'utf8')
                    stream    = open(os.path.join(zipparent,fn), 'rb')
                    if newext=='txt' or newext=='html':
                        dbcontent=open(os.path.join(zipparent,fn)).read()
                    else:
                        dbcontent = None
                    db.allfiles.insert(filename=newname, filepath=newpath,
                                       parentpath=newppath+'/', filetype=newext, 
                                       file=db.allfiles.file.store(stream,newname),
                                       datecreated=now, content=dbcontent, grupo=igrupo)
            result= {
                        'Parent' : parentpath,
                        'Name' : filename,
                        'Error' :'',
                        'Code' :0
                        }
    else:
        result = {
                    'Path' : parentpath,
                    'Name' : filename,
                    'Code' : 1,
                    'Error' : 'Folder already exists'
                }
    return result
    
#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
@service.json
def delete(param):
    igrupo=int(request.vars.grupo)
    path=request.vars.path
    #print "<--------------delete---------->"
    #print "path:",path
    filepaths=remove(path,pathset=[])
    for filepath in filepaths:
        if not filepath[-1]=='/':
            row=db((db.allfiles.filepath==filepath )&(db.allfiles.grupo==igrupo)).select()[0]
            filename=row.file
            os.remove(os.path.join(request.folder,'uploads',filename))
        db((db.allfiles.filepath==filepath )&(db.allfiles.grupo==igrupo)).delete()    
    result={
            'Error':'No Error',
            'Code':0,
            'Path': path 
           }        
    return result
     
#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
@service.json
def rename(param):
    igrupo=int(request.vars.grupo)
    #print "<---------rename--------->"
    oldpath=request.vars.old  
    #print "oldpath:",oldpath      
    #print "parentpath:",parentpath
    newname = request.vars.new.replace(' ','_')    
    result={
            'type':'',
            'Old Path':'',
            'New Path':'',
            'Old Name':'',
            'New eName':'',
            'parent':'',
            'Code':0,
            'Error':''
            } 
    if oldpath[-1]=='/':
        oldname=split_path(oldpath[:-1])[-1]
        parentpath=split_path(oldpath[:-1])[0]
        if not parentpath=='/':
            parentpath=parentpath+'/'
        row=db((db.allfiles.parentpath==parentpath)&(db.allfiles.filetype=='dir') \
        &(db.allfiles.filename==newname)&(db.allfiles.grupo==igrupo)).select()
        if len(row)==1:
            result['Code']=1
            result['Error']='Folder already exists'
            return result
        newpath=parentpath+newname+'/'
        result['type']='dir'
        db((db.allfiles.filepath==oldpath)&(db.allfiles.grupo==igrupo)).update(filepath=newpath,filename=newname,datemodified=now)
        renamedir(oldpath,oldname,newname)
    else:   
        oldname = split_path(oldpath)[-1]
        parentpath = split_path(oldpath)[0]
        if not parentpath=='/':
            parentpath=parentpath+'/'        
        newpath = parentpath + newname
        row=db((db.allfiles.parentpath==parentpath)&(db.allfiles.filepath==newpath)&(db.allfiles.grupo==igrupo)).select()
        if len(row)==1:
            result['Code']=1
            result['Error']='File already exists'
            return result
        result['type']='file'
        db((db.allfiles.filepath==oldpath)&(db.allfiles.grupo==igrupo)).update(filepath=newpath,filename=newname,datemodified=now)
    result['parent']=parentpath
    result['Old Path']= oldpath
    result['Old Name']=oldname
    result['New Path']=newpath
    result['New eName']=newname    
    return result 
    
#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
def renamedir(oldpath,oldname,newname):
    igrupo=int(request.vars.grupo)
    newpath=oldpath.replace(oldname,newname)
    rows=db((db.allfiles.parentpath==oldpath)&(db.allfiles.grupo==igrupo)).select()
    for row in rows:
        if row.filepath[-1]=='/':
            db((db.allfiles.parentpath==oldpath) \
            &(db.allfiles.grupo==igrupo)).update(parentpath=row.parentpath.replace(oldname,newname),datemodified=now)
            renamedir(row.filepath,oldname,newname)
            db((db.allfiles.filepath==row.filepath) \
            &(db.allfiles.grupo==igrupo)).update(filepath=row.filepath.replace(oldname,newname),datemodified=now)
        else:
            db((db.allfiles.filepath==row.filepath)&(db.allfiles.grupo==igrupo)). \
            update(filepath=row.filepath.replace(oldname,newname),parentpath=row.parentpath.replace(oldname,newname),datemodified=now)

#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
def add():
    igrupo=int(request.vars.grupo)   
    parentpath=request.vars.currentpath
    file=request.vars.file
    filename=file.filename.replace(' ','_')
    
    filepath=parentpath+filename
    filetype=os.path.splitext(filename)[1][1:]
    row=db((db.allfiles.parentpath==parentpath) &
           (db.allfiles.filepath==filepath) &
           (db.allfiles.filename==filename) &
           (db.allfiles.grupo==igrupo)).select()
    if not len(row):    
        db.allfiles.insert(filename=filename,filepath=filepath, \
            parentpath=parentpath,filetype=filetype,file=db.allfiles.file.store(file.file,filename),datecreated=now,grupo=igrupo)   
        result = {
                'Path' : parentpath,
                'Name' : filename,
                'Error' :'',
                'Code':0
            }
    else:
        result = {
                'Path' : parentpath,
                'Name' : filename,
                'Error' : 'File already exists',
                'Code':1
            }
        return '<textarea>'+str(result)+'</textarea>'
    row=db((db.allfiles.filename==filename)&(db.allfiles.grupo==igrupo)).select()[0]
    insertedfile=row.file
    outfile=open(output,'wb')
    try:
        _,filepath=db.allfiles.file.retrieve(insertedfile, nameonly=True)
        filesize=os.path.getsize(filepath)
        if filepath[-3:]=='txt' or filepath[-4:]=='html':
            filepath=os.path.normpath(filepath)
            filein=open(filepath,'r')
            dbcontent=filein.read()
            filein.close()
            db((db.allfiles.filename==filename)&(db.allfiles.grupo==igrupo)).update(filesize=filesize,content=dbcontent)
        else:
            db((db.allfiles.filename==filename)&(db.allfiles.grupo==igrupo)).update(filesize=filesize)
        outfile.close()        
    except:
        outfile.write(str(sys.exc_info()[1]))
        outfile.close()   

    return '<textarea>'+str(result)+'</textarea>'

#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
def downloadurl():
    """
    allows downloading of uploaded files
    http://..../[app]/default/download/[filename]
    """
    igrupo=int(request.vars.grupo)   
    filename=request.vars.filename
    file=db((db.allfiles.filename==filename)&(db.allfiles.grupo==igrupo)).select()[0]   
    return file.file

def download():
    return response.download(request,db)

def call():
    """
    exposes services. for example:
    http://..../[app]/default/call/jsonrpc
    decorate with @services.jsonrpc the functions to expose
    supports xml, json, xmlrpc, jsonrpc, amfrpc, rss, csv
    """
    session.forget()
    return service()


#@auth.requires_membership('miembros_%s'%request.vars.grupo)
@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('miembros_%s'%request.vars.grupo))
def remove(path,pathset):
    igrupo=int(request.vars.grupo)
    if path[-1]=='/':
        pathset.append(path)
        rows=db((db.allfiles.parentpath==path)&(db.allfiles.grupo==igrupo)).select()
        for row in rows:
            if row.filetype=='dir':
                remove(row.filepath,pathset=pathset)
            else:
                pathset.append(row.filepath)
    else:
        pathset.append(path)
    return pathset
    

