# -*- coding: utf-8 -*-
# (C) Copyright (C) 2012, 2013 Pablo Angulo
# This file is part of karakolas <karakolas.org>.

# karakolas is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as 
# published by the Free Software Foundation, either version 3 of the 
# License, or (at your option) any later version.

# karakolas is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU Affero General Public 
# License along with karakolas.  If not, see 
# <http://www.gnu.org/licenses/>.

from gluon.dal import Rows

@auth.requires_login()
def index():
    def link(field, type, ref):
        return URL(f='admin_red', vars=dict(grupo=field))
    return SQLTABLE(db(db.grupo.red==True).select(db.grupo.nombre, db.grupo.id),
                    linkto=link)

@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('webadmins'))
def admin_grupo():
    igrupo    = int(request.vars.grupo)
    grupo     = db.grupo[igrupo]
    if grupo.red:
        redirect(URL(c='redes', f='admin_red', vars=dict(red=igrupo)))
    #Comprueba que es un admin!
#    if not auth.
    iadmins   = auth.id_group('admins_%d'%igrupo)
    imiembros = auth.id_group('miembros_%d'%igrupo)
    return dict(igrupo=igrupo, iadmins=iadmins, imiembros=imiembros)

@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('webadmins'))
def miembros_grupo():
    igrupo     = int(request.vars.grupo)
    imiembros  = int(request.vars.miembros)
    new_member = FORM(FIELDSET(T('username del nuevo miembro: '), 
                                INPUT(_name='miembro_username', #_readonly='readonly',
                                      _id='miembro_username')),
                      FIELDSET(T('Unidad a la que pertenece: '), 
                                INPUT(_name='miembro_unidad', requires=IS_INT_IN_RANGE(0,1000))),
                      INPUT(_type='submit', _name='incluir_miembro', 
                             _value=T('Incluir miembro')),
#                      INPUT(_type='submit', _name='sacar_usuario', 
#                             _value=T('Sacar de la lista de espera')),
                             )
        
    if new_member.process().accepted:
        usuario = db.auth_user(username=request.vars.miembro_username)
        if usuario:
            pxg = db.personaXgrupo(grupo=igrupo, persona=usuario.id)
            if pxg and pxg.activo:
                pxg.update_record(unidad=request.vars.miembro_unidad)
                response.flash = T('el usuario ya estaba en el grupo. Hemos actualizado su número de unidad.')
            else:
                db.auth_user(usuario.id).update_record(registration_key='')
                db.auth_membership.insert(group_id=imiembros, user_id=usuario.id)
                if pxg:
                    pxg.update_record(activo=True, unidad=request.vars.miembro_unidad)
                else:
                    db.personaXgrupo.insert(grupo=igrupo, persona=usuario.id, 
                                            activo=True, unidad=request.vars.miembro_unidad)
                asunto = T('Has entrado en el grupo %s')%db.grupo(igrupo).nombre
                cuerpo = '<html>%s</html>'%db.textos_grupo(grupo=igrupo,slug='email_incorporacion_grupo').texto
                if not mail.send(to=usuario.email, 
                                  subject=asunto,
                                  message=cuerpo):
                    response.flash = T('El usuario %s es ahora miembro del grupo.'
                                       'Le hemos enviado un email para avisarle.'%
                            request.vars.miembro_username)
                else:
                    response.flash = T('El usuario %s es ahora miembro del grupo'%request.vars.miembro_username)
            ple = db.personaXlistaespera(grupo=igrupo,persona=usuario.id)
            if ple: ple.update_record(activo=False)
        else:
            response.flash = T('Usuario desconocido.')
    lista_solicitantes = db((db.personaXlistaespera.grupo==igrupo) &
                            (db.personaXlistaespera.activo==True) &
                            (db.personaXlistaespera.persona==db.auth_user.id))\
                         .select(db.auth_user.ALL,
                                 db.personaXlistaespera.comentario,
                                 orderby=db.personaXlistaespera.fecha_de_solicitud)
    return dict(new_member=new_member,
                igrupo=igrupo, imiembros=imiembros,
                lista_solicitantes=lista_solicitantes)

@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('webadmins'))
def sacar_de_lista_de_espera():
    ple = db.personaXlistaespera(persona=request.vars.uid, grupo=request.vars.grupo)
    if ple: ple.update_record(activo=False)
    return ""

@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('webadmins'))
def lista_miembros_en_grupo():
    igrupo    = int(request.vars.grupo)
    imiembros = int(request.vars.imiembros)    
    for k,v in request.vars.iteritems():
        if k.startswith('del_'):
            id = int(k[4:])
            db((db.auth_membership.group_id==imiembros) &
               (db.auth_membership.user_id==id)).delete()
            db.personaXgrupo(grupo=igrupo, persona=id).update_record(activo=False)
            ple = db.personaXlistaespera(grupo=igrupo,persona=id)
            if ple: ple.update_record(activo=False)

    miembros = db((db.personaXgrupo.grupo==igrupo) &
                  (db.personaXgrupo.persona==db.auth_user.id) &
                  (db.personaXgrupo.activo==True)) \
               .select(db.auth_user.ALL, db.personaXgrupo.unidad,
                       orderby=db.personaXgrupo.unidad)
    if db.grupo[igrupo].prueba:        
        for record in miembros:
            record.auth_user.email='xxx'
            record.auth_user.telefono='xxx'

    f = FORM(TABLE(TR(TD(T('Unidad')), TD(T('username')),
                      TD(T('Nombre')), TD(T('Teléfono')), TD(T('Email')),
                      TD(T('Eliminar del grupo'))),
                   *[TR(TD(u.personaXgrupo.unidad),
                        TD(u.auth_user.username),
                        TD('%s %s'%(u.auth_user.first_name, u.auth_user.last_name)), 
                        TD(u.auth_user.telefono or T('Desconocido')), TD(u.auth_user.email),
                        TD(INPUT(_value='Eliminar', _type='checkbox', _name='del_%s'%u.auth_user.id) ))
                     for u in miembros]),
            INPUT(_type='submit', _name='submit', _value='Sacar del grupo a los usuarios seleccionados'))

    return dict(grupos=f)

@auth.requires_membership('miembros_%s'%request.vars.grupo)
def info_personas():
    igrupo = int(request.vars.grupo)
    grupo  = db.grupo[igrupo]
    
    mensaje=None
    if grupo.discreto and not auth.has_membership('admins_%s'%igrupo):
        mensaje = T('Este grupo ha restringido el acceso a estos datos a los administradores del grupo')
        return dict(miembros=Rows(), grupo=grupo, mensaje=mensaje)
    elif grupo.prueba:
        mensaje = T('Se ocultan datos personales al tratarse de un grupo de prueba')

    if grupo.prueba:        
        miembros = []
        for m in db((db.personaXgrupo.grupo==igrupo) &
                      (db.personaXgrupo.persona==db.auth_user.id) &
                      (db.personaXgrupo.activo==True)) \
                   .select(db.auth_user.username, db.personaXgrupo.unidad,
                           orderby=db.personaXgrupo.unidad|db.auth_user.username):
            d = Storage(auth_user=
                        Storage(first_name='Xxxx', last_name='Xxxx', 
                                telefono='xxxx', email='xxxx'),
                        personaXgrupo=Storage())
            d.auth_user.usename=m.auth_user.username
            d.personaXgrupo.unidad=m.personaXgrupo.unidad
            miembros.append(d)
    else:
        miembros = db((db.personaXgrupo.grupo==igrupo) &
                      (db.personaXgrupo.persona==db.auth_user.id) &
                      (db.personaXgrupo.activo==True)) \
                   .select(db.auth_user.ALL, db.personaXgrupo.unidad,
                           orderby=db.personaXgrupo.unidad|db.auth_user.username)
        
    return dict(miembros=miembros, grupo=grupo, mensaje=mensaje)


@auth.requires_membership('webadmins')
def grid_all_grupos():
    grid = SQLFORM.grid(db.grupo)
    return locals()

@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('webadmins'))
def importar_lista_espera():
    igrupo = int(request.vars.grupo)
    try:
        t  = (k for k in request.vars if k.startswith('_table_name_')).next()
        #ce: campos extra  tp: sheet principal
        id_t = t[12:]
    except:
        id_t = None
    sheet = ERTable.factory(
        Field('nombre'),
        Field('apellido'),
        Field('email'),
        Field('telefono'),
        Field('comentario', 'text'),
        master_fields=['email'],
        _id=id_t
    )
    if sheet.accepts(request.vars):
        rv = sheet.process_request(request.vars, keep_order=True)
        import datetime
        f  = request.now
        d  = datetime.timedelta(seconds=1)
        errores_email = []
        for fields in rv.values():
            record = db.auth_user(email=fields['email'])
            if record:
            #si el usuario ya esta en la web, probablemente sus datos sean mejores
            #que los de la tabla
#                record.update_record(**user_vals) 
                uid = record.id
            else:
                uid = db.auth_user.insert(
                    username=fields['email'], email=fields['email'],
                    first_name=fields['nombre'], last_name=fields['apellido'],
                    password=''.join(chr(random.randrange(32,123)) for _ in xrange(20) ),
                    telefono=fields['telefono']
                    )
                gid = db.auth_group.insert(
                        description='Group uniquely assigned to user %d'%uid, 
                        role='user_%d'%uid)
                db.auth_membership.insert(user_id=uid, group_id=gid)
            asunto = T('Has entrado en la lista de espera del grupo %s')%db.grupo(igrupo).nombre
            cuerpo = '<html>%s</html>'%db.textos_grupo(grupo=igrupo,slug='email_incorporacion_lista_de_espera').texto
            if not mail.send(to=fields['email'], 
                              subject=asunto,
                              message=cuerpo):
                errores_email.append(fields['email'])
            #Lista de espera            
            r1 = db.personaXgrupo(grupo=igrupo, persona=uid)
            r2 = db.personaXlistaespera(grupo=igrupo, persona=uid)
            if (r1 and r1.activo) or (r2 and r2.activo):
                pass
            else:
                if r2:
                    r2.update_record(activo=True, comentario=fields['comentario'])
                else:
                    db.personaXlistaespera.insert(grupo=igrupo, persona=uid,
                                                  fecha_de_solicitud=f + d*fields['order'],
                                                  comentario=fields['comentario'])
        if not errores_email:
            session.flash = T('Las personas mencionadas se han incorporado a la lista de espera con éxito. Les hemos enviado un email para avisarles.')
        else:
            #TODO: log errores_email
            session.flash = T('Las personas mencionadas se han incorporado a la lista de espera con éxito. Algunos emails no han podido enviarse. Por favor avísales tu.')
        redirect(URL(c='grupo', f='admin_grupo', vars=dict(grupo=igrupo)))
    elif sheet.errors:
        response.flash = T('Errores al importar la lista de espera')
    return dict(sheet=sheet, grupo=igrupo)

@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or 
               auth.has_membership('webadmins'))
def importar_al_grupo():
    igrupo = int(request.vars.grupo)
    try:
        t  = (k for k in request.vars if k.startswith('_table_name_')).next()
        #ce: campos extra  tp: sheet principal
        id_t = t[12:]
    except:
        id_t = None
    sheet = ERTable.factory(
        Field('email', requires=IS_EMAIL()),
        Field('unidad', 'integer'),
        master_fields=['email'],
        _id=id_t
    )
    if sheet.accepts(request.vars):
        rv = sheet.process_request(request.vars, keep_order=True)
        import datetime
        f  = request.now
        d  = datetime.timedelta(seconds=1)
        errores_email = []
        for fields in rv.values():
            record = db.auth_user(email=fields['email'])
            if record:
            #si el usuario ya esta en la web, probablemente sus datos sean mejores
            #que los de la tabla
#                record.update_record(**user_vals) 
                uid = record.id
            else:
                uid = db.auth_user.insert(
                    username=fields['email'], email=fields['email'],
                    password=''.join(chr(random.randrange(32,123)) for _ in xrange(20) )
                    )
                gid = db.auth_group.insert(
                        description='Group uniquely assigned to user %d'%uid, 
                        role='user_%d'%uid)
                db.auth_membership.insert(user_id=uid, group_id=gid)
            asunto = T('Has entrado en el grupo %s')%db.grupo(igrupo).nombre
            cuerpo = '<html>%s</html>'%db.textos_grupo(grupo=igrupo,slug='email_incorporacion_grupo').texto
            if not mail.send(to=fields['email'], 
                              subject=asunto,
                                  message=cuerpo):
                errores_email.append(fields['email'])

            #Lista de espera            
            r1 = db.personaXgrupo(grupo=igrupo, persona=uid)
            imiembros = auth.id_group('miembros_%d'%igrupo)
            if r1:
                r1.update_record(activo=True, unidad=fields['unidad'])
            else:
                db.personaXgrupo.insert(grupo=igrupo, persona=uid, unidad=fields['unidad'])
            db.auth_membership.update_or_insert(group_id=imiembros, user_id=uid)
            r2 = db.personaXlistaespera(grupo=igrupo, persona=uid)
            if r2:
                r2.update_record(activo=False)
            else:
                db.personaXlistaespera.insert(
                    grupo=igrupo, persona=uid, activo=False,
                    fecha_de_solicitud=f + d*fields['order'],
                    comentario=T('este usuario se incorporó directamente al grupo sin pasar por la lista de espera en %s')%f)
        if not errores_email:
            session.flash = T('Las personas mencionadas se han incorporado al grupo con éxito. Les hemos enviado un email para avisarles.')
        else:
            #TODO: log errores_email
            session.flash = T('Las personas mencionadas se han incorporado al grupo con éxito. Algunos emails no han podido enviarse. Por favor avísales tu.')
        redirect(URL(c='grupo', f='admin_grupo', vars=dict(grupo=igrupo)))
    elif sheet.errors:
        response.flash = T('Errores al importar la lista de espera')
    return dict(sheet=sheet, grupo=igrupo)

@auth.requires(auth.has_membership('admins_%s'%request.vars.grupo) or
               auth.has_membership('webadmins'))
def editar_datos_grupo():
    igrupo    = int(request.vars.grupo)
    grupo     = db.grupo[igrupo]
    #no se permite cambiar el nombre del grupo: ¿podría ser legitimo?
    #se puede hacer desde appadmin, me parece correcto que tengan que avisar al sysadmin
    form_grupo = SQLFORM(db.grupo, igrupo, buttons=[])
    form_components = form_grupo.components
    slugs = db(db.textos_grupo.grupo==igrupo).select(db.textos_grupo.slug, db.textos_grupo.texto)
    editar_textos = DIV(*[FIELDSET(LABEL(r.slug),
            TEXTAREA(r.texto, _class='texto_grupo', _name='texto_grupo_%s'%r.slug))
                           for r in slugs],
                         **dict(_id='div_textos_grupo'))
    boton_submit = INPUT(_type='submit', _name='submit', _value=T('Enviar'))
    form_components.extend([editar_textos, boton_submit])
    form = FORM(*form_components)
    if form.accepts(request.vars):
        vars_grupo  = {}
        vars_textos = {}
        for k,v in request.post_vars.iteritems():
            if k=='submit':
                continue
            elif k.startswith('texto_grupo_'):
                vars_textos[k]=v
            else:
                if v=='on':v=True
                vars_grupo[k]=v
        grupo.update_record(**vars_grupo)
        for k,v in vars_textos.iteritems():
            db.textos_grupo(grupo=igrupo, slug=k[12:]).update_record(texto=v)
        session.flash = T('Datos actualizados')
        redirect(URL(c='grupo', f='editar_datos_grupo', vars=dict(grupo=igrupo)))
    elif form.errors:
        response.flash = T('Ha habido errores...')
    return dict(form=form, grupo=grupo)

