# -*- coding: utf-8 -*-
# (C) Copyright (C) 2012, 2013 Pablo Angulo
# This file is part of karakolas <karakolas.org>.

# karakolas is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as 
# published by the Free Software Foundation, either version 3 of the 
# License, or (at your option) any later version.

# karakolas is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU Affero General Public 
# License along with karakolas.  If not, see 
# <http://www.gnu.org/licenses/>.


#########################################################################
import os
import os.path
import subprocess
from encodings import codecs
import datetime
from collections import defaultdict
from math import floor

def index():
    redirect(URL(f='vista_pedidos'))

@auth.requires_membership('miembros_%s'%request.vars.grupo)
def vista_pedidos():    
    igrupo    = int(request.vars.grupo)
    grupo     = db.grupo[igrupo]
    today = datetime.date.today()
    pedidos = defaultdict(list)

    #TODO: refactor usando dame_pedidos_por_fecha

    s = db((db.pedido.abierto==True) &
           (db.pedido.productor==db.productor.id) &
           (db.productor.grupo==igrupo)).select(db.pedido.ALL)

    cantidad_total = db.item.cantidad.sum()
    def has_pedido(pid):
        ct = db((db.peticion.productoXpedido == db.productoXpedido.id) &
                (db.productoXpedido.pedido==pid) &
                (db.peticion.persona==auth.user.id) ) \
             .select(cantidad_total)
        return ct.first()[cantidad_total]
#        return bool(db((db.item.pedido==pid) &
#                       (db.item.persona==auth.user.id)).count())

    for row in s:
        pedidos[row.fecha_reparto].append(
            TAG.dl(TAG.dt(T('Pedido de %s ')%(row.productor.nombre),
                          A(T('Editar tu pedido') if has_pedido(row.id) else T('Pedir'), 
                            _href=URL(f='peticion.html', vars={'pedido':row.id}))),
                   TAG.dd(row.info_cierre or '')))

    s2 = db((db.pedido.abierto==True) &
            (db.proxy_pedido.pedido==db.pedido.id) &
            (db.pedido.productor==db.productor.id) &
            (db.proxy_pedido.activo==True) &
            (db.proxy_pedido.grupo==igrupo))  \
          .select(db.pedido.ALL, db.proxy_pedido.fecha_reparto,
                  db.proxy_pedido.comentarios,
                  db.productor.nombre,
                  orderby=db.pedido.fecha_reparto)
    for row in s2:
        pedidos[row.proxy_pedido.fecha_reparto].append(
            TAG.dl(TAG.dt(T('Pedido coordinado de %s ')%(row.productor.nombre),
                          A(T('Editar tu pedido') if has_pedido(row.pedido.id) else T('Pedir'), 
                            _href=URL(f='peticion.html', vars={'pedido':row.pedido.id, 'grupo':igrupo}))),
                   TAG.dd(row.proxy_pedido.comentarios or ''))
        )

    if pedidos:
        ls = pedidos.items()
        ls.sort()
             
        d = DIV(*[DIV(H3('Fecha de reparto: %s'%format_fecha(f)),  
                      DIV(*[trow for trow in pedidos_f])) 
                      for f,pedidos_f in ls])
    else:
        d =  P(T('No hay pedidos abiertos en este momento'))
    return dict(pedidos_disponibles=d)

@auth.requires(autoriza_pedido(request.vars, perms='rw'))
def peticion():
    ipedido  = int(request.vars.pedido)
    pedido   = db.pedido(ipedido)
    ipersona = auth.user.id
    if 'grupo' in request.vars:
        igrupo     = int(request.vars.grupo)
        coordinado = True
    else:
        igrupo     = db.pedido(ipedido).productor.grupo.id
        coordinado = False
    unidad = db.personaXgrupo(persona=ipersona, grupo=igrupo).unidad

    if not pedido.abierto:
        redirect(URL(f='vista_pedidos', vars=dict(grupo=grupo_del_pedido(ipedido))))

    query = ((db.productoXpedido.pedido==ipedido)          &
             (db.productoXpedido.producto==db.producto.id) &
             (db.producto.categoria==db.categorias_productos.id))
    if coordinado:
        query &= query_mask(igrupo)
    productos = db(query) \
                  .select(db.producto.ALL, db.productoXpedido.ALL,
                          db.categorias_productos.nombre,
                          orderby=db.producto.categoria|db.producto.nombre)
    data_cat = defaultdict(list)
    for row in productos:
        data_cat[row.categorias_productos.nombre, row.producto.categoria].append((
             row.producto.nombre,
             row.producto.descripcion or '', row.producto.granel,
             row.productoXpedido.precio_base, row.productoXpedido.precio_final, 
             row.productoXpedido.id,          row.productoXpedido.destacado))

    p2extra = dame_valores_extra(ipedido)
    extra   = dict((row.productoXpedido.id, p2extra[row.producto.id]) for row in productos)
    
    cantidades = ','.join("'cantidad_%d'"%row.productoXpedido.id 
                          for row in productos)
    rec =db.comentarioApeticion(pedido=ipedido, persona=ipersona)
    comentario = rec.texto if rec else ''

    def productos_cat(cat_id, cat_nombre, data):
        return DIV(
#                H3(cat_nombre),
                TABLE(TR(TH('Producto'), TH(''),#TH('Descripción'), 
                         TH('Precio unitario'), TH('Cantidad'), TH('Precio total')),
                      *[TR(TD(nombre_producto),
                           TD(A(IMG(_src=URL('static',
                           'images/alerta.png' if destacado else 'images/info.png')),
                                SPAN(descripcion, 
                                     TAG.br(), 'Precio base: %s'%preciob, 
                                     UL(*[LI(item) for item in extra[pid]])), 
                                _href='#', _class='my_tooltip')), 
                           TD(SPAN(preciof, _id='precio_unitario_%d'%pid), XML('&euro;'),
                              INPUT(_type='hidden', _name='granel_%d'%pid,
                                    _id='granel_%d'%pid, _value='%s'%bool(granel)),
                              _class='precio'), 
                           TD(INPUT(_name='cantidad_%d'%pid, 
                                    _id  ='cantidad_%d'%pid,
                                    _class='cantidad')),
                           TD(SPAN('', _id='precio_producto_%d'%pid), XML('&euro;')),
                              _class='precio')
                       for nombre_producto, descripcion, granel, preciob, preciof, pid, destacado in data],
                       **dict(_id='table_cat_%s'%cat_id)),
                **dict(_id='div_cat_%s'%cat_id, _title=cat_nombre, _class='collapsibleContainer'))
    
    form = FORM(DIV(*[productos_cat(cat_id, cat_nombre, data) 
                      for (cat_nombre, cat_id), data in sorted(data_cat.iteritems())]),
                P('Precio total: ', SPAN('0.0', _id='precio_total'), XML('&euro;')),
                DIV(H3('¿Tienes algo que añadir?'),
                    TEXTAREA(_name='comentarioApeticion', value=comentario)),
                INPUT(_type='submit', _name='submit', _id='submit', _value='Enviar'), 
                INPUT(_type='hidden', _name='no_pedido', _value='%d'%ipedido), 
                INPUT(_type='hidden', _id='cambios', _value='0'), 
                INPUT(_type='hidden', _id='ids_productos', _value=','.join(
                        ['%d'%d[-2] for _,data in data_cat.iteritems() for d in data])), 
                _method='post')

    peticiones = db((db.peticion.persona==ipersona) &
                    (db.peticion.grupo==igrupo) &
                    (db.peticion.productoXpedido==db.productoXpedido.id) &
                    (db.productoXpedido.pedido==ipedido) &
                    (db.productoXpedido.producto==db.producto.id))\
                 .select(db.productoXpedido.id, db.peticion.cantidad, db.producto.granel)
    for row in peticiones:
        q = row.peticion.cantidad or 0
        form.vars['cantidad_%d'%row.productoXpedido.id] = q if row.producto.granel else int(q)

    if form.accepts(request.vars, keepvalues=True):
        ps = []
        for k,v in request.vars.iteritems():
            if k.startswith('cantidad_'):
                try:
                    if ('.' in v) or (',' in v):
                        ippp = int(k.split('_')[1])
                        ps.append(ippp)
                    if v: _=Decimal(v)
                except:
                    form.errors[k] = T('Por favor escribe un número válido')
        s = db((db.productoXpedido.id.belongs(ps)) &
               (db.productoXpedido.producto==db.producto.id) &
               (db.producto.granel==False)).select()
        if s:
            for row in s:
                name = 'cantidad_%d'%row.productoXpedido.id
                form.errors[name] = T('Este producto no se puede pedir a granel')

        if form.errors:
            response.flash = T('Ha habido problemas al procesar tu petición')
        else:
            pids = [row.productoXpedido.id for row in productos]
            db(db.peticion.productoXpedido.belongs(pids) &
               (db.peticion.grupo==igrupo) &
               (db.peticion.persona ==ipersona)  ).delete()
            db(db.item.productoXpedido.belongs(pids) &
               (db.item.grupo==igrupo) &
               (db.item.unidad==unidad)  ).delete()
#            for row in productos:
#                db((db.item.productoXpedido==row.productoXpedido.id) &
#                   (db.item.unidad ==unidad)  &
#                   (db.item.grupo==igrupo)).delete()
#                db((db.peticion.productoXpedido==row.productoXpedido.id) &
#                   (db.peticion.grupo==igrupo) &
#                   (db.peticion.persona ==ipersona)  ).delete()

            for k,v in request.vars.iteritems():
                #Es posible para un usuario "malicioso" pedir productos coordinados
                #que su grupo ha decidido no pedir
                #Aquí podría evitarlo, pero es tontería...
                if k.startswith('cantidad_'):
                    _, ppp = k.split('_')
                    ippp = int(ppp)
                    v = Decimal(v.replace(',','.') if v else Decimal())
                    if v:
                        db.peticion.insert(productoXpedido=ippp, grupo=igrupo,
                                           persona=ipersona, cantidad=v)
            peticion_a_item(ipedido, igrupo, unidad)

            comentario = request.vars.comentarioApeticion
            if comentario:
                rec = db.comentarioApeticion(pedido=ipedido, persona=ipersona)
                if rec:
                    rec.update_record(texto=comentario)
                else:
                    db.comentarioApeticion.insert(pedido=ipedido, persona=ipersona,
                                                  texto=comentario)
            #equivalente a:
    #            db.comentarioApeticion.update_or_insert(
    #                ((db.comentarioApeticion.pedido=ipedido) &
    #                 (db.comentarioApeticion.persona=ipersona)),
    #                pedido=ipedido, persona=ipersona, texto=comentario)

            session.flash = 'Pedido de %s registrado correctamente'%pedido.productor.nombre
            redirect(URL(f='ver_pedido', vars={'pedido':ipedido}))

    response.files.append(URL('static', 'css/diQuery-collapsiblePanel.css'))
    response.files.append(URL('static', 'js/diQuery-collapsiblePanel.js'))
    response.files.append(URL('static', 'js/peticion.js'))

    return dict(elige_productos=form, 
                nombre_productor=pedido.productor.nombre,
                descripcion_productor=XML(pedido.productor.descripcion),
                fecha_reparto=pedido.fecha_reparto)

@auth.requires(puede_pedir(request.vars.pedido))
def ver_pedido():
    ipersona = auth.user.id
    ipedido  = int(request.vars.pedido)
    rows = db((db.peticion.persona==ipersona)      & 
              (db.peticion.productoXpedido==db.productoXpedido.id)        & 
              (db.productoXpedido.pedido==ipedido) ) \
           .select(db.productoXpedido.producto, db.peticion.cantidad,
                   db.productoXpedido.precio_final)
    data = [(row.productoXpedido.producto.nombre,
             row.productoXpedido.precio_final,
             pprint_c(row.peticion.cantidad),
             row.peticion.cantidad*row.productoXpedido.precio_final)
            for row in rows if row.peticion.cantidad>0]
    resumen = TABLE(TR(TD('Producto'), TD('Precio unitario'), TD('Cantidad'), TD('Precio')),
                    *[TR(TD(nombre),
                         TD(preciou, XML('&euro;')),
                         TD(cantidad),
                         TD(pprint_p(preciop), XML('&euro;')) )
                      for nombre, preciou, cantidad, preciop in data])
    total = SPAN(pprint_p(sum(preciop for _,_,_,preciop in data)), XML('&euro;'))
    row   = db.comentarioApeticion(pedido=ipedido, persona=ipersona)
    comentario = (row and row.texto) or ''
    return dict(pedido=db.pedido(ipedido),
                 total=total,
                 resumen=resumen,
                 comentario=comentario)       

@auth.requires_membership('miembros_%s'%request.vars.grupo)
def informes():
    igrupo = int(request.vars.grupo)
    #Separa abiertos, cerrados, historicos
    q = request.vars.tipo_pedidos
    if q not in TIPO_PEDIDO:
        q = PEDIDOS_ABIERTOS
    links = UL(*[LI(A(T('Pedidos %ss')%v, 
                      _href=URL(f='informes', 
                                vars=dict(tipo_pedidos=k, grupo=igrupo))))
                 for k,v in TIPO_PEDIDO.iteritems() if k!=q],
               **dict(_id='links_listas_de_pedidos'))
    
    tp = TIPO_PEDIDO[q]
    pedidos = dame_pedidos_por_fecha(igrupo, q)
    return dict(pedidos=pedidos,
                links=links, tp=tp, grupo=igrupo)

@auth.requires(auth.has_membership(role='admins_%s'%request.vars.grupo) or
               auth.has_membership(role='miembros_%s'%request.vars.grupo))
def consulta():
    try:
        igrupo = int(request.vars.grupo)
        grupo  = db.grupo(igrupo)
        unidad = db.personaXgrupo(persona=auth.user.id, grupo=igrupo).unidad
    except:
        session.flash = T('Problema con la URL')
        redirect(URL(f='gestion_pedidos', 
                     vars=dict(tipo_pedidos=PEDIDOS_ABIERTOS, grupo=igrupo)))

    fs_abiertos = dame_pedidos_por_fecha(igrupo, PEDIDOS_ABIERTOS)
    fs_cerrados = dame_pedidos_por_fecha(igrupo, PEDIDOS_CERRADOS)
    fechas_abiertos = [(f,','.join('%d'%r.pedido.id for r in (r0+r1))) for f,(r0,r1) in fs_abiertos]
#    fechas_abiertos.sort()
    fechas_cerrados = [(f,','.join('%d'%r.pedido.id for r in (r0+r1))) for f,(r0,r1) in fs_cerrados]
#    fechas_cerrados.sort()
    return dict(unidad=unidad, fechas_abiertos=fechas_abiertos, 
                grupo=igrupo, fechas_cerrados=fechas_cerrados)
    
