# -*- coding: utf-8 -*-
# (C) Copyright (C) 2012, 2013 Pablo Angulo
# This file is part of karakolas <karakolas.org>.

# karakolas is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as 
# published by the Free Software Foundation, either version 3 of the 
# License, or (at your option) any later version.

# karakolas is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU Affero General Public 
# License along with karakolas.  If not, see 
# <http://www.gnu.org/licenses/>.

#
#########################################################################
import os
import os.path
import subprocess
from encodings import codecs
import datetime
from collections import defaultdict

def index():
    redirect(URL(c='default'))

@auth.requires_membership('admins_%s'%request.vars.grupo)
def vista_productores():
    igrupo = int(request.vars.grupo)
    form  = SQLFORM(db.productor, 
                    fields=['nombre', 'email', 'telefono', 
                            'direccion', 'descripcion', 'info_pedido'])
    form2 = FORM(INPUT(_type='string', _name='link_to_csv', requires=IS_URL()),
                 INPUT(_type='submit'))
    if form.process(dbio=False, formname='form_nuevo_productor').accepted:
        form.vars.id = iproductor = db.productor.insert(grupo=igrupo, **dict(form.vars))
        crea_pedido_fantasma(iproductor)
        for row in db(db.grupoXred.red==igrupo).select(db.grupoXred.grupo):
            ppid = db.proxy_productor.insert(grupo=row.grupo, productor=iproductor)
        response.flash = T('Se ha creado un nuevo productor: %s')%form.vars.nombre
    elif form.errors:
        response.flash = T('El formulario de nuevo productor tiene errores, Por favor revisalos.')
    if form2.process(formname='form_importar_productor').accepted:
        import urllib
        u = urllib.urlopen(form2.vars.link_to_csv)
        t = u.read()
        importar_productor(igrupo,t)
        response.flash = T('Se ha incorporado el nuevo productor')
    elif form2.errors:
        response.flash = T('La url tiene errores, Por favor revisalos.')
    return dict(nuevo_productor=form, nuevo_productor_url=form2,
                 productores=db(db.productor.grupo==igrupo) \
                             .select(db.productor.ALL, orderby=db.productor.nombre),
                 grupo=igrupo)

@auth.requires_membership('miembros_%s'%request.vars.grupo)
def info_productores():
    igrupo = int(request.vars.grupo)
    propios = db(db.productor.grupo==igrupo).select(db.productor.ALL)
    lista_pc = []
    for row in db(db.grupoXred.grupo==igrupo).select(db.grupoXred.red):
        lista_pc.append((row.red, 
                         db(db.productor.grupo==row.red) \
                                .select(db.productor.ALL)))
    return dict(productores=propios,
                 lista_pc=lista_pc,
                 igrupo=igrupo, nombre_grupo=db.grupo[igrupo].nombre)

@auth.requires_membership(grupo_del_productor(request.vars.productor))
def edita_productor():
    iproductor = int(request.vars.productor)
    productor  = db.productor[iproductor]
    igrupo     = productor.grupo
    form = SQLFORM(db.productor, iproductor, showid=False, deletable=True,
#                   fields=['nombre', 'email', 'telefono', 'direccion', 
#                           'descripcion', 'info_pedido']
                )
    if form.process().accepted:
        redirect(URL(f='vista_productores', vars={'grupo':igrupo}))
    elif form.errors:
        response.flash = 'form has errors'

    return dict(edita_productor=form,
                productor=productor)

@auth.requires_membership('admins_%s'%request.vars.grupo)
def productores_coordinados():
    igrupo = int(request.vars.grupo)
    lista_pc = {}
    for row in db(db.grupoXred.grupo==igrupo).select(db.grupoXred.red):
        lista_pc[row.red] = db(db.productor.grupo==row.red) \
                                .select(db.productor.ALL)
    return dict(lista_pc=lista_pc,
                 grupo=igrupo)

@auth.requires_membership('admins_%s'%request.vars.grupo)
def edita_productor_coordinado():
    igrupo = int(request.vars.grupo)
    iproductor = int(request.vars.productor)
    pp = db.proxy_productor(grupo=igrupo, productor=iproductor)
    if pp:
        form = SQLFORM(db.proxy_productor, pp.id, fields=['aceptado', 'comentarios'], showid=False)
    else:
        form = SQLFORM(db.proxy_productor, fields=['aceptado', 'comentarios'], showid=False)

    if form.accepts(request.vars, session):
        if pp:
            pp.update_record(comentarios=form.vars.comentarios)
            ppid = pp.id
        else:
            ppid = db.proxy_productor.insert(grupo=igrupo, productor=iproductor,
                                      comentarios=form.vars.comentarios)
        response.flash = 'form accepted'
        form = SQLFORM(db.proxy_productor, ppid, fields=['comentarios'], showid=False)
    elif form.errors:
        response.flash = 'form has errors'

    return dict(productor=iproductor, grupo=igrupo, edit_form = form)

@auth.requires_membership('webadmins')
def grid_all_productos():
    grid = SQLFORM.grid(db.producto)
    return locals()

@auth.requires_membership('webadmins')
def grid_all_productores():
    grid = SQLFORM.grid(db.productor)
    return locals()

@auth.requires_membership('webadmins')
def grid_all_categorias():
    grid = SQLFORM.grid(db.categorias_productos)
    return locals()

@auth.requires(tiene_acceso_al_grupo(request.vars.productor))
def vista_productos():
    s = db((db.producto.productor==int(request.vars.productor)) &
           (db.producto.activo==True))
    return dict(#new_producto=form,
            grupo=grupo_del_productor(request.vars.productor),
            productos=s.select(db.producto.ALL,
                                  orderby=db.producto.categoria |
                                          db.producto.nombre))
    
script_productos = '''<script type="text/javascript">
//my own limited eval, that is XSS-safe
eval_arit_no_parens = function(s){
    //replace double negative (may happen from a call to eval_arit)
    s = s.replace(/--/g,'+').replace(/\++/g,'+').replace(/\+-/g,'-');
    if(s.match(/\?/)){
        var ls = s.split(/[\?\:]/g);
        if(eval_arit_no_parens(ls[0])){
            return eval_arit_no_parens(ls[1]);
        }else{
            return eval_arit_no_parens(ls[2]);
        }
    }
    var items = s.split(/([\+\*\-\/])/g);

    var j=0;
    while(j<items.length){
        if(items[j]=='*' | items[j]=='/'){
            if(items[j]=='*'){
                res = items[j-1]*items[j+1];
            }else if(items[j]=='/'){
                res = items[j-1]/items[j+1];
            }
            items.splice(j-1,3,res);
            j = j-3;
        }
        j++;
    }

    var s=items[0]===""?0.0:parseFloat(items[0]);
    for(j=1;j<items.length;j+=2){
        if(items[j]=='+'){
            s += parseFloat(items[j+1]);
        }else{
            s -= parseFloat(items[j+1]);
        }
    }    
    return s;
}
//my own limited eval, XSS safe
eval_arit = function(s){
//TODO: usa la linea siguiente para ahorrar tiempo
//    var items = s.split(/([\(\)])/g);
    var j=0, nest = 0, last;
    var open = [];
    while(j<s.length){
        if(s[j]=='('){
            nest++;
            open.push(j);
        }else if(s[j]==')'){
            last = open.pop();
            s = s.slice(0,last) + eval_arit_no_parens(s.slice(last+1,j)) + s.slice(j+1);
            j = last-1;
        }
        j++;
    }
    return eval_arit_no_parens(s);
}

aplicar_formula = function(){
    var formula = $('#formula').val();
    if(formula.match(/[$'";\[\]]/) ){
        alert('Por favor usa sólo operaciones aritméticas.');
        return true;
    }
    
    var preciof;

    if(formula=='precio_base'){
        $('#ertable_%(id)s_th_precio_final').hide();
        $('textarea[id^="ertable_%(id)s_cell_precio_final_"]').parent().hide();
    }else{
        $('#ertable_%(id)s_th_precio_final').show();
        $('textarea[id^="ertable_%(id)s_cell_precio_final_"]').parent().show();
    }
    var fields = $('#_ertable_%(id)s_fields').val().split(',');
    var trs = $('#ertable_%(id)s tr');
    for(var j=1; j<trs.length; j++){
        var rid = trs[j].id.split('_')[3];
        var expr = formula;

        //columnas
        for(var k=0;k<fields.length;k++){
            var v = $('#ertable_%(id)s_cell_'+fields[k]+'_'+rid).val();
            v = v?v.replace(',','.'):0;
            if(v=='on'){
                if ($('#ertable_%(id)s_cell_'+fields[k]+'_'+rid).attr('checked')){
                    v=1;
                }else{
                    v=0;
                }
            }
            var r = new RegExp(fields[k], "g");
            expr = expr.replace(r, v);
        }

        //campos globales
        var campos = $('tr[id^=ertable_%(id2)s_row_]');
        for(var k=0;k<campos.length;k++){
            var nombre = campos[k].children[1].children[0].value;
            var valor  = campos[k].children[2].children[0].value;           
            var r = new RegExp(nombre, "g");
            expr = expr.replace(r, valor);
        }

        try {
            preciof = eval_arit(expr);
        } catch (e) {
            if (e instanceof ReferenceError) {
                preciof = 'Error';
            }else{
                alert(e.name + ": " + e.message);
                return true;
            } 
        }
        //redondea:
        preciof = Math.round(preciof*100)/100;
        $('#ertable_%(id)s_cell_precio_final_'+rid).val( preciof);
    }
}
prepara_aplicar_formula = function(){
    $('textarea,input').off('change.aplicar_formula');
    $('textarea,input').on('change.aplicar_formula', aplicar_formula);
    aplicar_formula();
}
$(document).ready(function(){
    $('textarea[id^="ertable_%(id)s_cell_precio_final_"]').attr('readonly', 'readonly');
    prepara_aplicar_formula();
    $('.ertable').on('nueva_columna', prepara_aplicar_formula);
    $('.ertable').on('nueva_fila', prepara_aplicar_formula);
})
</script>
'''

FORMULA_NO_VARS = re.compile('[ \+\*\-\?\/\(\):0-9\.]+')

@auth.requires_membership(grupo_del_productor(request.vars.productor))
def productos():
    try:
        iproductor = int(request.vars.productor)
        productor  = db.productor[iproductor]
    except:
        session.flash = T('No se ha indicado el productor cuyos productos quieres editar.\n Redirigimos a la página de productores.')
        redirect(URL(f='vista_productores'))
    if 'pedido' in request.vars:
        ipedido = int(request.vars.pedido)
        pedido  = db.pedido[ipedido]
        assert pedido.productor==iproductor
        pedido_fantasma = False
    else:
        pedido = db.pedido(productor=iproductor,fecha_reparto=FECHA_FANTASMA)
        ipedido = pedido.id
        pedido_fantasma = True
    actualiza_productos_desde_el_pedido(ipedido)

    try:
        t1, t2 = [k for k in request.vars if k.startswith('_table_name_')]
        #ce: campos extra  tp: tabla principal
        id_ce = (t1[12:] if request.vars[t1]=='campo_extra'
                         else t2[12:] )
        id_tp = (t1[12:] if request.vars[t1]=='producto'
                         else t2[12:] )
    except ValueError:
        id_ce = id_tp = None

    columnas = ['nombre', 'precio_base', 'descripcion', 'categoria', 'granel', 'destacado', 'temporada', 'precio_final']
    tabla  = ERTable(db.producto, 
                     columnas,
                     ((db.producto.productor==iproductor) & (db.producto.activo==True)),
                     master_fields=['nombre'],
                     values = {'productor':iproductor, 'activo':True},
                     extra_columns_table=db.columna_extra,
                     extra_columns_values={'productor':iproductor},
                     extra_columns_names=('nombre', 'tipo'),
                     extra_data=TABLAS_VALORES_EXTRA,
                     extra_data_fields=('producto', 'columna', 'valor'),
                     add_controls=False,
                     add_new_columns=True,
                     _id=id_tp,
                     _class='table_productos'
                     )
    formula_field = FIELDSET(T('Formula para el precio final: '), 
                             TEXTAREA(_name='formula', _id='formula',
                                      value=productor.formula_precio_final,
                                      _cols="2", _rows="60"))
    cs = db(db.campo_extra.productor==iproductor).select()
    campos_extra = ERTable(db.campo_extra,
                          ['nombre', 'valor'],
                          master_fields=['nombre'],
                          values = {'productor':iproductor},
                          add_controls=False,
                          add_n_rows_at_a_time=(1,),
                          _id=id_ce)
    boton_submit = FORM(INPUT(_type='submit', _name='submit', 
                         _value=T('Grabar los cambios')))
    if db(db.campo_extra.productor==iproductor).count():
        botones_avanzados = DIV(formula_field,
                                _id='div_controles_avanzados')
    
        form = MERGED_FORM(campos_extra, botones_avanzados, 
                               tabla, boton_submit)
        div_form = DIV(form, XML(script_productos%dict(id=tabla._id, id2=campos_extra._id)))
    else:
        botones_avanzados = DIV(campos_extra,
                                formula_field,
                                _id='div_controles_avanzados')

        form = MERGED_FORM(botones_avanzados, tabla, boton_submit)
        div_form = DIV(form, XML(script_productos%dict(id=tabla._id, id2=campos_extra._id)))

    if request.vars.submit:

        #Separamos las variables de uno y otro formulario
        vars_ce = dict((k,v) for (k,v) in request.vars.iteritems() if id_ce in k)
        vars_tp = dict((k,v) for (k,v) in request.vars.iteritems() if id_tp in k)

        #Campos Extra
        ce_a = campos_extra.accepts(vars_ce, dbio = False)

        formula = request.vars.formula
        has_formula = formula and (formula != 'precio_base')
        formula_field.element('#formula')[0] = formula
        nombres = [w.strip() for w in FORMULA_NO_VARS.split(formula) 
                             if w and not w.isspace()]
        nombres_vars = set(v for (k,v) in vars_ce.iteritems() if '_cell_nombre_' in k)
        nombres_vars.update(''.join(k.split('_')[4:]) 
                      for (k,v) in vars_tp.iteritems() if '_nueva_columna_' in k)
        nombres_vars.update(('precio_base', 'granel'))
        formula_refs = all((nombre in nombres_vars) for nombre in nombres)
        #Observacion: en un navegador sin javascript habria que rellenar precio_final a mano
        formula_ok   = all(v!='NaN' for (k,v) in vars_tp.iteritems() 
                           if '_precio_final_' in k)

        #Tabla principal
        tp_a = tabla.accepts(vars_tp, 
                             dbio=(ce_a and formula_ok and formula_refs), 
                             on_delete=lambda s:s.update(activo=False))

        if ce_a and formula_ok and formula_refs and tp_a:
            db.productor[iproductor] = dict(formula_precio_final=formula)

            campos_extra.accepts(vars_ce)

            mueve_productos_al_pedido(ipedido)
            if pedido_fantasma:
                session.flash = 'Los productos de %s han sido actualizados'%productor.nombre
                redirect(URL(c='productores', f='vista_productores',
                    vars=dict(grupo=productor.grupo)))
            else:
                if db((db.pedido.productor==iproductor) &
                      (db.pedido.fecha_reparto>pedido.fecha_reparto)).count() == 0:
                    mueve_productos_al_pedido_fantasma(iproductor)
                else:
                    actualiza_productos_desde_pedido_fantasma(iproductor)
                actualiza_precios_peticion(ipedido)
                session.flash = 'Los productos del pedido de %s \n para el %s han sido actualizados'%(productor.nombre, pedido.fecha_reparto)
                redirect(URL(c='gestion_pedidos', f='gestion_pedidos', 
                    vars=dict(grupo=productor.grupo)))
        else:
            errores_precio_final = [k for k in tabla.errors
                                       if k.split('_',3)[-1].startswith('precio_final')]
            for k in errores_precio_final:
                tabla.errors.pop(k)
            flash_messages = []
            if tabla.errors:
                flash_messages.append( 'La tabla de productos tiene errores. Por favor completa los campos marcados en rojo. ')
            if not ce_a:
                flash_messages.append( 'El formulario de campos globales tiene errores. ')
            if (not tabla.errors) and ce_a:
                if not formula_refs:
                    flash_messages.append( 'La fórmula para el precio final hace referencia a campos que no están presentes.\nPor favor comprueba los campos avanzados. ')
                    #TODO: esto no funciona, lo dejo por ser poco importante
#                    form.errors.formula = T('La fórmula para el precio final hace referencia a campos que no están presentes.')
                elif not formula_ok:
                    flash_messages.append(  'La formula para el precio final no da resultados válidos.\nPor favor comprueba los campos avanzados. ')
#                    form.errors.formula = T('La fórmula para el precio final no da resultados válidos. Repasa la aritmética y los paréntesis, y que todos los campos mencionados en la fórmula tienen un valor numérico válido.')
            response.flash = T('\n'.join(flash_messages))
    return dict(productos=div_form,
                productor=productor,
                pedido_fantasma=pedido_fantasma, pedido=ipedido,
                tabla_id=tabla._id
                )
        
#@auth.requires_membership(grupo_del_productor(request.vars.productor))
@auth.requires(tiene_acceso_al_grupo(request.vars.productor))
def ver_info_pedido():
    iproductor = int(request.vars.productor)
    productor  = db.productor[iproductor]
    return dict(info=XML(productor.info_pedido),
                 productor=productor)

