# -*- coding: utf-8 -*-
# (C) Copyright (C) 2012, 2013 Pablo Angulo
# This file is part of karakolas <karakolas.org>.

# karakolas is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as 
# published by the Free Software Foundation, either version 3 of the 
# License, or (at your option) any later version.

# karakolas is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU Affero General Public 
# License along with karakolas.  If not, see 
# <http://www.gnu.org/licenses/>.


@auth.requires_login()
def index():
    def link(field, type, ref):
        return URL(f='admin_red', vars=dict(grupo=field))
    return SQLTABLE(db(db.grupo.red==True).select(db.grupo.nombre, db.grupo.id),
                    linkto=link)

@auth.requires_membership('admins_%s'%request.vars.red)
def admin_red():
    ired    = int(request.vars.red)
    red     = db.grupo[ired]
    if not red.red:
        redirect(URL(c='grupos', f='admin_grupo', vars=dict(grupo=ired)))
    #Comprueba que es un admin!
#    if not auth.
    iadmins = auth.id_group('admins_%d'%ired)
    return dict(ired=ired, iadmins=iadmins)

@auth.requires(auth.has_membership(group_id=request.vars.iadmins))
def nuevo_admin_red():
    iadmins   = int(request.vars.iadmins)
    new_admin = FORM(FIELDSET(T('username del nuevo administrador: '), 
                                INPUT(_name='miembro_username')),
                       INPUT(_type='submit', _name='incluir_miembro', 
                             _value=T('Incluir miembro')))

#    new_admin = SQLFORM.factory(Field('username', 
#                                widget=SQLFORM.widgets.autocomplete(
#                                        request, db.auth_user.username, 
#                                        db.auth_user.id, min_length=2)))
#    if new_admin.accepts(request.vars):

    if new_admin.accepts(request.vars):
#        raise Exception, request.vars
        try:
            user_id = db.auth_user(username=request.vars.miembro_username).id
            if db((db.auth_membership.group_id==iadmins)&
                  (db.auth_membership.user_id==user_id)).count()>0:
                response.flash = 'el usuario ya es administrador'                
            else:
                db.auth_membership.insert(**dict(group_id=iadmins, user_id=user_id))
                response.flash = 'ok'
        except:
            response.flash = 'Usuario desconocido'
    return dict(new_admin=new_admin, iadmins=iadmins)


@auth.requires_membership('admins_%s'%request.vars.red)
def lista_grupos_en_red():
    ired    = int(request.vars.red)
    for k,v in request.vars.iteritems():
        if k.startswith('del_'):
            id = int(k[4:])
            db((db.grupoXred.red==ired) &
               (db.grupoXred.grupo==id)).delete()
            for row in db(db.productor.grupo==ired).select(db.productor.id):
                db(db.proxy_productor.productor==row.id).delete()
            
    grupos = db((db.grupoXred.red==ired) &
                (db.grupoXred.grupo==db.grupo.id)) \
               .select(db.grupo.ALL)
    f = FORM(TABLE(TR(TD(T('Grupo o Red')),
                      TD(T('Nombre')),
                      TD(T('Eliminar de la red'))),
                   *[TR(TD(T('Red') if g.red else T('Grupo')),
                        TD(g.nombre), 
                        TD(INPUT(_value='Eliminar', _type='checkbox', _name='del_%s'%g.id) ))
                     for g in grupos]),
            INPUT(_type='submit', _name='submit', _value='Sacar de la red a los grupos seleccionados'))

    return dict(grupos=f)

@auth.requires_membership('admins_%s'%request.vars.red)
def grupos_en_red():
    ired    = int(request.vars.red)
    new_grupo = SQLFORM.factory(Field('grupo', 
                                 requires=IS_IN_DB(db, db.grupo, '%(nombre)s')))
    if new_grupo.process().accepted:
        igrupo = int(new_grupo.vars.grupo)
        if (db((db.grupoXred.grupo==igrupo)&
               (db.grupoXred.red==ired)                    ).count()>0 or
            igrupo==ired ):
            pass
        else:
            db.grupoXred.insert(**dict(grupo=igrupo, red=ired))
            for row in db(db.productor.grupo==ired).select(db.productor.id):
                db.proxy_productor.insert(productor=row.id,
                                          grupo=igrupo)
            response.flash = 'ok'
    return dict(new_grupo=new_grupo, ired=ired)


