# -*- coding: utf-8 -*-
# (C) Copyright (C) 2012, 2013 Pablo Angulo
# This file is part of karakolas <karakolas.org>.

# karakolas is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as 
# published by the Free Software Foundation, either version 3 of the 
# License, or (at your option) any later version.

# karakolas is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU Affero General Public 
# License along with karakolas.  If not, see 
# <http://www.gnu.org/licenses/>.

def represent(table, record):
    try:
        format = table._format
        if callable(format):
            return format(record)
        else:
            return format % record
    except TypeError:
        return str(record.id) if record else ''

def pretty_record(table, r):
    ls = []
    for tf in table:
        t,f = str(tf).split('.')
        field =db[t][f]
        type  = field.type
        if type=='id' or not field.readable:
            continue
        elif type.startswith('reference'):
            ls.append( '%s,"%s"'%(f,
                represent(db[type.split(' ')[-1]], r[t+'.'+f]).replace('"','""')))
        elif type.startswith('list:reference'):
#                line += str(r[t+'.'+f])
            reft = db[type.split(' ')[-1]]
            ls.append( '%s,"%s"'%(f,
                ','.join(represent(reft, ir) for ir in r[t+'.'+f]).replace('"','""')))
        else:
            ls.append( '%s,"%s"'%(f,str(r[t+'.'+f] or '').replace('"','""') ))
    return XML('\n'.join(ls))


def pretty_csv(results, fields):
    ls = []
#    def field_type(f):
#        if isinstance(totales, gluon.dal.Expression):
#            return 
#        t,f = str(f).split('.')
#        if db[t][f].type.startswith('reference'):
#            ...
    fs = [str(f).split('.') for f in fields]
    ls.append(','.join(str(f) for f in fields))
    for r in results:
        line=[]
        for tf in fields:
            if type(tf) == gluon.dal.Expression:
                line.append( str(r[tf]) )
                continue                
            t,f = str(tf).split('.')
            if db[t][f].type.startswith('reference'):
                line.append( represent(db[db[t][f].type.split(' ')[-1]], r[t+'.'+f]) )
            elif db[t][f].type.startswith('list:reference'):
#                line += str(r[t+'.'+f])
                line.append( ','.join(represent(db[db[t][f].type.split(' ')[-1]], ir) for ir in r[t+'.'+f]) )
            else:
                line.append( str(r[t+'.'+f] or '') )
        ls.append(','.join('"%s"'%e if (',' in e) else e for e in line))
    return XML('\n'.join(ls))
    
#def pretty_sheet_csv(results):
#    return
