# -*- coding: utf-8 -*-
# (C) Copyright (C) 2012, 2013 Pablo Angulo
# This file is part of karakolas <karakolas.org>.

# karakolas is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as 
# published by the Free Software Foundation, either version 3 of the 
# License, or (at your option) any later version.

# karakolas is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU Affero General Public 
# License along with karakolas.  If not, see 
# <http://www.gnu.org/licenses/>.

#########################################################################
import os

def get_version(filename):
    filepath = os.path.join('applications', request.application, filename)
    try:
        f = open(filepath, mode='r')
    except IOError:
        f = open(filepath, mode='w')
        f.write('0.0.1')
        f.close()
        f = open(filepath, mode='r')
    s = f.read()
    f.close()
    return s,tuple(int(n) for n in s.split('.'))

def less(t1, t2):
    for v1,v2 in zip(t1,t2):
        if v1 > v2:
            return False
        if v1 < v2:
            return True            
    return True
    
def prepopulate_tables_run_once():
    r = db.auth_group(role='webadmins')
    if not r:
        db.auth_group.insert(role='webadmins',description=T('Administradores de este sitio web'))

    r = db.categorias_productos(codigo=50000000)
    if not r:
        db.categorias_productos.insert(codigo=50000000, nombre=T("Alimentos"))

    r = db.categorias_productos(codigo=-1)
    if not r:
        db.categorias_productos.insert(codigo=-1, nombre="_Ninguna de las anteriores")

def ajustes_para_upload_separate():
    from shutil import move
    join = os.path.join
    uploads_path = join('applications', request.application, 'uploads')
    upload_fields = ['allfiles.file', 'plugin_wiki_attachment.filename', 'pedido.xls']
    def ujoin(*args):
        return join(uploads_path,*args)
    for p in upload_fields:
        if not os.path.exists(ujoin(p)):
            os.mkdir(ujoin(p))
    for f in os.listdir(uploads_path):
        try:
            table,c1,c2,ext = f.rsplit('.',3)
            if table in upload_fields:
                ddir = ujoin(table,c1[:2])
                if not os.path.exists(ddir):
                    os.mkdir(ddir)            
                move(ujoin(f), join(ddir,f))
        except ValueError:
            continue

def textos_grupo_por_defecto(igrupo, nombre_grupo=None, host=None):
    host = host or True
    textos_por_defecto = {
    'email_incorporacion_lista_de_espera':
'''<p>Hola:</p>

<p>Te hemos incorporado a la lista de espera de nuestro grupo de consumo %(nombre_grupo)s. Para ello, hemos incorporado tus datos al programa karakolas que usamos para la gestión del grupo de consumo. Puedes consultar tus datos en la url:</p>

<a href="%(url_karakolas)s">%(url_karakolas)s</a>

<p>Si no habías entrado antes en karakolas, hemos credo un usuario con nombre de usuario igual a tu dirección de email, y tienes que cambiar el password en esta url:</p>

<a href="%(url_recuperar_password)s">%(url_recuperar_password)s</a>

<p>Puedes borrar tu cuenta del programa y todos tus datos serán borrados, pero si lo haces, no podremos contactarte si se abre una plaza en el grupo. Para cualquier duda puedes consultar la <a href="%(url_privacidad)s">política de privacidad del sitio</a></p>

<p>Un saludo!</p>
''', 'email_incorporacion_grupo':
'''<p>Bienvenida!</p>

<p>Te hemos incorporado a nuestro grupo de consumo, %(nombre_grupo)s. Para que puedas participar en los pedidos, te hemos abierto una cuenta en karakolas, el programa que usamos para la gestión del grupo de consumo. La url de nuestra instalación de karakolas es:</p>

<a href="%(url_karakolas)s">%(url_karakolas)s</a>

<p>Si no habías entrado antes en karakolas, hemos credo un usuario con nombre de usuario igual a tu dirección de email, y tienes que cambiar el password en esta url:</p>

<a href="%(url_recuperar_password)s">%(url_recuperar_password)s</a>

<p>Puedes a aprender a manejar la aplicación los tutoriales de <a href="http://karakolas.org/spip.php?rubrique2">karakolas.org</a>, o leyendo la ayuda de la propia aplicación, siguiendo los links a la "ayuda de esta página" que encontrarás en cualquier página de karakolas, pero lo mejor es que te pongas en contacto con nosotras para aprender a manejarlo.</p>

<p>Saludos</p>
'''}
    nombre_grupo = nombre_grupo or db.grupo(igrupo).nombre
    contexto = {'url_karakolas':URL(c='default',f='index', scheme='http',host=host),
                'url_privacidad':URL(c='default',f='index',args=['privacidad'], scheme='http',host=host),
                'url_recuperar_password':URL(c='default',f='user',args=['request_reset_password'], scheme='http',host=host),
                'nombre_grupo':nombre_grupo}
    for slug,texto in textos_por_defecto.iteritems():
        r = db.textos_grupo(grupo=igrupo, slug=slug)
        if not r:
            db.textos_grupo.insert(grupo=igrupo, slug=slug, texto=texto%contexto)

def textos_grupo_por_defecto_todos(host=None):
    for r in db(db.grupo.red==False).select(db.grupo.id, db.grupo.nombre):
        textos_grupo_por_defecto(r.id,r.nombre,host)

def crea_pedidos_fantasma():
    for row in db(db.productor).select(db.productor.id):
        crea_pedido_fantasma(row.id)

snew_version,new_version = get_version('VERSION')
_,old_version = get_version('private/DONE_UPGRADE')
if new_version==old_version:
    pass
else:
    if old_version == (0,0,1):
        if db._dbname=='mysql':
            create_mysql_indices_run_once()
        prepopulate_tables_run_once()    
    if less(old_version,(1,0,0)):
        ajustes_para_upload_separate()
    if less(old_version, (1,0,1)):
        r = db.paginas_especiales(slug='welcome')
        if not r:
            WELCOME_TEXT=T('''<p>Esta es la página de inicio de tu instalacion de karakolas.</p>
            
            <ol>
            <p>Te recomendamos que sigas los siguientes pasos:</p>
                <li>Registrar un usuario.</li>
                <li>Añadir ese usuario al grupo 'webadmins' usando el <a href="%(url_auth_membership)s">interfaz de administracion</a> (<a href="%(url_auth_membership_https)s">con el https</a> si no conectas desde localhost)</li>
                <li>Aparecerá un menú 'Wedadmin' que te permitirá crear un grupo nuevo.</li>
                <li>Usa el link para <em>incorporacion en bloque al grupo</em> como una forma rápida de incorporar gente (pueden ser emails falsos si sólo quieres probar la aplicación).</li>
                <li>Si esta instalación es pública, cambia este texto en la página de <a href="%(url_edicion)s">edicion</a></li>
            </ol>
            '''%{'url_edicion':URL(c='default', f='edita',args=['welcome']),
                 'url_auth_membership':URL(c='appadmin', f='insert', args=['db','auth_membership']),
                 'url_auth_membership_https':URL(c='appadmin', f='insert', args=['db','auth_membership'], scheme='https')})

            db.paginas_especiales.insert(slug='welcome', title=T('Bienvenida a Karakolas'), body=WELCOME_TEXT)
    if less(old_version,(1,1,0)):
        textos_grupo_por_defecto_todos()
    if less(old_version,(1,1,1)):
        crea_pedidos_fantasma()
    
    f = open('applications/%s/private/DONE_UPGRADE'%request.application, mode="w")
    f.write(snew_version)
    f.close()

