# -*- coding: utf-8 -*-
# (C) Copyright (C) 2012, 2013 Pablo Angulo
# This file is part of karakolas <karakolas.org>.

# karakolas is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as 
# published by the Free Software Foundation, either version 3 of the 
# License, or (at your option) any later version.

# karakolas is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU Affero General Public 
# License along with karakolas.  If not, see 
# <http://www.gnu.org/licenses/>.


#########################################################################

response.title = ' '.join(word.capitalize() for word in request.application.split('_'))
response.subtitle = T('Coordinación de grupos de consumo')

## read more at http://dev.w3.org/html5/markup/meta.name.html
response.meta.author = 'Pang e Isidro <info@karakolas.org> '
response.meta.description = 'Herramienta para la gestión de grupos de consumo'
response.meta.keywords = 'grupo de consumo, logística, web2py, python'
response.meta.generator = 'Web2py Web Framework'
response.meta.copyright = 'This is free software: Affero GPL. Check details at https://savannah.nongnu.org/projects/karakolas'

## your http://google.com/analytics id
response.google_analytics_id = None

#########################################################################

def build_menu():
    if not auth.user:
        return [(T('Home'), False, URL('default','index'), [
                    (T('Regístrate por primera vez'), False, URL('default','user',args=['register']), []), 
                    (T('Entra (si ya te has registrado)'), False, URL('default','user',args=['login']), []), 
                    (T('¿Olvidaste tu usuaria?'), False, URL('default','user',args=['retrieve_username']), []), 
                    (T('¿Olvidaste tu contraseña?'), False, URL('default','user',args=['request_reset_password']), []), 
                    ] ),
                 (T('Entra'), False, URL('default','user',args=['login']), [])
                 ]
                 
    opciones = [(T('Home'), False, URL('default','index'), 
                 [(T('Listas de espera'), False, URL('default','listas_de_espera'), [])]
                )]
    id = auth.user.id
    grupos = db((db.auth_membership.user_id==id) &
                (db.auth_membership.group_id==db.auth_group.id)) \
            .select(db.auth_group.ALL, orderby=db.auth_group.role)

    if not any((g.role.startswith('admins') or
                 g.role.startswith('red') or
                 g.role.startswith('miembros') or
                 g.role == 'webadmins')
                 for g in grupos):
        return opciones
    for g in grupos:
        if g.role == 'webadmins':
            opts = {} if request.is_local else dict(scheme='https', host=True)
            opciones.append(
               (T('Webadmin'), False, 
                URL(c='webadmin', f='index', **opts), [
               (T('Categorías'), False, 
                URL(c='productores', f='grid_all_categorias', **opts), []),
               (T('Grupos'), False, 
                URL(c='webadmin', f='index', **opts), []),
               (T('Grid grupos'), False, 
                URL(c='grupo', f='grid_all_grupos', **opts), []),
               (T('Nuevo grupo'), False, 
                URL(c='webadmin', f='add_group', **opts), []),
               (T('Productores'), False, 
                URL(c='productores', f='grid_all_productores', **opts), []),
               (T('Productos'), False, 
                URL(c='productores', f='grid_all_productos', **opts), []),
                ]))
            continue
        s,k = g.role.split('_')
        id = int(k)
        if s == 'user':
            continue
        ngrupo = db.grupo(id).nombre
        es_red = db.grupo(id).red
        if es_red and s == 'admins':
            opciones.append(
               (ngrupo, False, 
                URL(c='redes', f='admin_red', vars=dict(red=id)), [
               (T('Administración'), False, 
                URL(c='redes', f='admin_red', vars=dict(red=id)), []),
                    (T('Productores'), False, 
                     URL('productores','vista_productores', vars=dict(grupo=id)), []),
               (T('Gestión de pedidos'), False, 
                URL(c='gestion_pedidos', f='gestion_pedidos', vars=dict(grupo=id)), [])
                ]))
        elif s == 'admins':
            menu_datos    = (T('Datos del grupo'), False, 
                             URL('grupo','editar_datos_grupo', vars=dict(grupo=id)), [])
            menu_personas = (T('Personas'), False, 
                             URL('grupo','admin_grupo', vars=dict(grupo=id)), [])
            menu_prods    = (T('Productores'), False, 
                URL('productores','vista_productores', vars=dict(grupo=id)), [])
            menu_pedidos  = (T('Gestión de pedidos'), False, 
                URL(c='gestion_pedidos', f='gestion_pedidos', vars=dict(grupo=id)), [])
            menu_stats    = (T('Estadisticas'), False, 
                URL(c='estadisticas',f='stat_grupo', vars=dict(grupo=id)), [])
            menu_ficheros = (T('Archivos del grupo'), False, 
                URL(c='ficheros',f='index', vars=dict(grupo=id)), [])
            if db(db.grupoXred.grupo==id).count():
                ls = [menu_datos,
                      menu_personas,
                      menu_prods,
                    (T('Redes'), False, URL(c='productores', f='productores_coordinados', vars=dict(grupo=id)), []),
                      menu_pedidos, menu_ficheros,
#                    (T('Pedidos coordinados'), False, URL(c='gestion_pedidos', f='pedidos_coordinados', vars=dict(grupo=id)), []),
                    menu_stats
                ]
            else:
                ls = [menu_datos, menu_personas, menu_prods, menu_pedidos, menu_ficheros, menu_stats]
            opciones.append(('Admin %s'%ngrupo, False,
                   URL(c='default', f='index', vars=dict(grupo=id)), ls))
        elif s == 'miembros':
            opciones.append(
               (ngrupo, False, 
                URL(c='peticion', f='vista_pedidos', vars=dict(grupo=id)), 
                [('Personas', False, 
                  URL(c='grupo', f='info_personas', vars=dict(grupo=id)), []),
                 ('Productores', False, 
                  URL(c='productores', f='info_productores', vars=dict(grupo=id)), []),
                 ('Pedir', False, 
                  URL(c='peticion', f='vista_pedidos', vars=dict(grupo=id)), []),
                 ('Consulta tus pedidos', False, 
                  URL(c='peticion', f='consulta', vars=dict(grupo=id)), []),
                 ('Ver informes', False, 
                  URL(c='peticion', f='informes', vars=dict(tipo_pedidos='cerrados', grupo=id, )), []),
                 (T('Archivos del grupo'), False, 
                  URL(c='ficheros',f='index', vars=dict(grupo=id)), []),
                 (T('Estadisticas'), False, 
                  URL(c='estadisticas',f='index'), []),
                 ]))
    opciones.append(('Ayuda', False,
           URL(c='plugin_wiki', f='page', args=['ayuda']), 
               [ ('', False, A(
                    T('Ayuda de esta página'), 
                    _href=URL('plugin_wiki', 'page', 
                      args=['ayuda_%s_%s'%(request.controller, request.function)]),
                    _target='_blank')) ]
#               [ (T('Ayuda de esta página'), False, 
#                  dict(_href=URL('plugin_wiki', 'page', 
#                      args=['ayuda_%s_%s'%(request.controller, request.function)]),
#                        _target='_blank')) ]                        
           ))
    return opciones

response.menu = build_menu()      


