import unittest

from gluon.globals import Request

# Create a test database that's laid out just like the "real" database
import copy
test_db = DAL('sqlite://testing.sqlite')  # Name and location of the test DB file

for tablename in db.tables:  # Copy tables!
    table_copy = [copy.copy(f) for f in db[tablename]]
    test_db.define_table(tablename, *table_copy)
    
db = test_db  # Rename the test database so that functions will use it instead of the real database
for tablename in db.tables:  # Copy tables!
    db[tablename].truncate()

db.commit() 
#import commands
#print commands.getoutput('pwd')
db.import_from_csv_file(open("applications/karakolas/private/db_test.csv"))

#execfile("applications/api/controllers/10.py", globals())

db.commit()

class TestPrettyPrintDecimal(unittest.TestCase):
    def setUp(self):
        pass
#        request = Request()  # Use a clean Request object

    def testPrettyPrintDecimal(self):
        cs = {Decimal('7.25'):'7.25', 
              Decimal('7.5'):'7.5', 
              Decimal('7'):'7', 
              Decimal('-7.123'):'-7.12',
              Decimal('70'):'70', 
              Decimal('-70.10'):'-70.1', 
              }
        for k,v in cs.iteritems():
            self.assertEquals(pprint_c(k),v)

class TestStupid(unittest.TestCase):
    def setUp(self):
        pass

    def testStupid_interaction_with_db(self):
        k = db(db.grupo).count()
        import datetime
        db.grupo.insert(nombre='XXX Grupo de Prueba %s'%datetime.datetime.now())
        self.assertEquals(k+1, db(db.grupo).count())
        db(db.grupo.nombre.startswith('XXX')).delete()
        self.assertEquals(k, db(db.grupo).count())

#class TestListActiveGames(unittest.TestCase):
#    def setUp(self):
#        request = Request()  # Use a clean Request object

#    def testListActiveGames(self):
#        # Set variables for the test function
#        request.post_vars["game_id"] = 1
#        request.post_vars["username"] = "spiffytech"

#        resp = list_active_games()
#        db.commit()
#        self.assertEquals(0, len(resp["games"]))

suite = unittest.TestSuite()
suite.addTest(unittest.makeSuite(TestPrettyPrintDecimal))
suite.addTest(unittest.makeSuite(TestStupid))
unittest.TextTestRunner(verbosity=2).run(suite)


